#region Copyright Syncfusion Inc. 2001-2018.
// Copyright Syncfusion Inc. 2001-2017. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;
using System.Diagnostics;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Text;


namespace EJServices.Controllers
{
    public class UploadBoxController : ApiController
    {
        public static List<DropDownData> FileList { get; set; }

        static UploadBoxController()
        {
            FileList = new List<DropDownData>();
        }

        public void MergeChunkFile(string fullPath, Stream chunkContent)
        {
            try
            {
                using (FileStream stream = new FileStream(fullPath, FileMode.Append, FileAccess.Write, FileShare.ReadWrite))
                {
                    using (chunkContent)
                    {
                        chunkContent.CopyTo(stream);
                    }
                }
            }
            catch (IOException ex)
            {
                throw ex;
            }
        }

        [AcceptVerbs("Post")]
        public void Save()
        {
            
            try
            {
                if (HttpContext.Current.Request.Files.AllKeys.Length > 0)
                {
                    var sampleDemo = HttpContext.Current.Request.Form["chunk-index"];
                    var httpPostedChunkFile = HttpContext.Current.Request.Files["chunkFile"];
                    if (httpPostedChunkFile != null)
                    {
                        var index = HttpContext.Current.Request.Form["chunk-index"];
                        var saveFile = HttpContext.Current.Server.MapPath("UploadedFiles");
                        var SaveFilePath = Path.Combine(saveFile, httpPostedChunkFile.FileName);
                        if (index == "0")
                        {
                            httpPostedChunkFile.SaveAs(SaveFilePath);
                        }
                        else
                        {
                            MergeChunkFile(SaveFilePath, httpPostedChunkFile.InputStream);
                        }
                        HttpResponse ChunkResponse = HttpContext.Current.Response;
                        ChunkResponse.Clear();
                        ChunkResponse.ContentType = "application/json; charset=utf-8";
                        ChunkResponse.StatusDescription = "File uploaded succesfully";
                        ChunkResponse.End();
                    }
                    var httpPostedFile = HttpContext.Current.Request.Files["UploadFiles"];
                    if (httpPostedFile != null)
                    {
                        var fileSave = HttpContext.Current.Server.MapPath("UploadedFiles");
                        if (!Directory.Exists(fileSave))
                        {
                            Directory.CreateDirectory(fileSave);
                        }
                        fileSavePath = Path.Combine(fileSave, httpPostedFile.FileName);
                        if (!File.Exists(fileSavePath))
                        {
                            httpPostedFile.SaveAs(fileSavePath);
                            // View the uploaded document using document editor
                            Process.Start(fileSavePath);
                            HttpResponse Response = HttpContext.Current.Response;
                            Response.Clear();
                            Response.ContentType = "application/json; charset=utf-8";
                            Response.StatusDescription = "File uploaded succesfully";
                            Response.End();
                        }
                        else
                        {
                            HttpResponse Response = HttpContext.Current.Response;
                            Response.Clear();
                            Response.Status = "204 File already exists";
                            Response.StatusCode = 204;
                            Response.StatusDescription = "File already exists";
                            Response.End();
                        }
                    }
                }
            }
            catch (Exception e)
            {
                HttpResponse Response = HttpContext.Current.Response;
                Response.Clear();
                Response.ContentType = "application/json; charset=utf-8";
                Response.StatusCode = 204;
                Response.Status = "204 No Content";
                Response.StatusDescription = e.Message;
                Response.End();
            }
        }

        [AcceptVerbs("Post")]
        public void Remove()
        {
            try
            {
                var fileSave = HttpContext.Current.Server.MapPath("UploadedFiles");
                var fileName = HttpContext.Current.Request.Files["UploadFiles"].FileName;
                var fileSavePath = fileSave + "\\" + fileName;
                if (System.IO.File.Exists(fileSavePath))
                {
                   System.IO.File.Delete(fileSavePath);
                }
                HttpResponse Response = HttpContext.Current.Response;
                Response.Clear();
                Response.Status = "200 Ok";
                Response.StatusCode = 200;
                Response.StatusDescription = "File removed successfully.";
                Response.End();
            }
            catch (Exception e)
            {
                throw (new Exception(e.Message));
            }
        }

        public class DropDownData
        {
            public string fileStream { get; set; }
            public string fileName { get; set; }
        }
    }
}